var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import pathToRegexp from 'path-to-regexp';

export default function initAppManager(w, history) {
  var _class, _temp, _initialiseProps;

  return _temp = _class = function () {
    _createClass(AppManager, null, [{
      key: '_browserPath',
      get: function get() {
        var browserState = history.getState();
        return (browserState.hash || '').split('?')[0];
      }
    }]);

    function AppManager(config, analytics) {
      _classCallCheck(this, AppManager);

      _initialiseProps.call(this);

      if (!config) {
        throw new Error('Config not specified. Aborting.');
      }

      var appScriptImports = config.appScriptImports,
          guestApps = config.guestApps,
          appSlots = config.appSlots,
          guestAppScripts = config.guestAppScripts;


      this._analytics = analytics || {
        error: function error(mock) {
          return mock;
        },
        namespace: 'mock' };
      this._appScriptImports = appScriptImports;
      this._guestApps = guestApps;
      this._appSlots = appSlots;
      this._guestAppScripts = guestAppScripts;

      this._pathCheckers = Object.keys(guestApps || {}).reduce(function (apps, appName) {
        var _Object$assign;

        return Object.assign({}, apps, (_Object$assign = {}, _Object$assign[appName] = pathToRegexp(guestApps[appName].appPath), _Object$assign));
      }, {});
    }

    AppManager.prototype._getAppFromPath = function _getAppFromPath() {
      var _this = this;

      var path = AppManager._browserPath;
      return Object.keys(this._pathCheckers).find(function (appName) {
        return _this._pathCheckers[appName].exec(path);
      });
    };

    return AppManager;
  }(), _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this._getManagedSlotScripts = function (appName) {
      var emptyAppSlots = Object.keys(_this2._appSlots).reduce(function (emptySlots, slotName) {
        var _Object$assign2;

        return Object.assign(emptySlots, (_Object$assign2 = {}, _Object$assign2[_this2._appSlots[slotName].name] = null, _Object$assign2));
      }, {});
      var appDisplayScripts = _this2._guestApps[appName].display;

      return appDisplayScripts.reduce(function (scripts, displayScriptName) {
        var guestAppScript = _this2._guestAppScripts[displayScriptName];

        if (!guestAppScript.managed) {
          return scripts;
        }

        return guestAppScript.slots.reduce(function (scriptsInSlots, appScriptSlotName) {
          var _Object$assign3;

          if (!(appScriptSlotName in scriptsInSlots) || scriptsInSlots.appScriptSlotName) {
            return scriptsInSlots;
          }

          return Object.assign({}, scriptsInSlots, (_Object$assign3 = {}, _Object$assign3[appScriptSlotName] = displayScriptName, _Object$assign3));
        }, scripts);
      }, emptyAppSlots);
    };

    this._getSlotElement = function (slotName) {
      if (!w) {
        _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_element.no_window', id: slotName });
        return null;
      }

      var slot = _this2._appSlots[slotName];

      if (!slot) {
        _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_element.no_slot', id: slotName });
        return null;
      }

      var element = w.document.querySelector('.' + slot.elementClass);

      if (!element) {
        _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_element.no_element', id: slotName });
        return null;
      }

      return element;
    };

    this._getAppScript = function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(appScriptName) {
        var appScriptImport, _Object$assign4, newScript;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(_this2._appScripts && _this2._appScripts[appScriptName])) {
                  _context2.next = 2;
                  break;
                }

                return _context2.abrupt('return', _this2._appScripts[appScriptName]());

              case 2:
                appScriptImport = _this2._appScriptImports[appScriptName];

                if (!(typeof appScriptImport !== 'function')) {
                  _context2.next = 6;
                  break;
                }

                _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_script.not_function', id: appScriptName });
                return _context2.abrupt('return', null);

              case 6:
                _context2.prev = 6;
                _context2.next = 9;
                return appScriptImport();

              case 9:
                newScript = _context2.sent;

                if (newScript) {
                  _context2.next = 13;
                  break;
                }

                _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_script.no_file', id: appScriptName });
                return _context2.abrupt('return', null);

              case 13:
                if ('version' in newScript) {
                  _context2.next = 16;
                  break;
                }

                _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_script.invalid_script', id: appScriptName });
                return _context2.abrupt('return', null);

              case 16:

                _this2._appScripts = Object.assign({}, _this2._appScripts, (_Object$assign4 = {}, _Object$assign4[appScriptName] = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          return _context.abrupt('return', newScript);

                        case 1:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, _this2);
                })), _Object$assign4));

                return _context2.abrupt('return', newScript);

              case 20:
                _context2.prev = 20;
                _context2.t0 = _context2['catch'](6);

                _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.get_script.import', id: appScriptName });
                return _context2.abrupt('return', null);

              case 24:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, _this2, [[6, 20]]);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    this._getPageScripts = function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(appName) {
        var slotScripts, appScriptImports;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                slotScripts = _this2._getManagedSlotScripts(appName);
                appScriptImports = Object.keys(slotScripts).filter(function (slotName) {
                  return Boolean(slotScripts[slotName]);
                }).map(function () {
                  var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(slotName) {
                    var appScript;
                    return regeneratorRuntime.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _this2._getAppScript(slotScripts[slotName]);

                          case 2:
                            appScript = _context3.sent;
                            return _context3.abrupt('return', { script: appScript, slot: slotName, name: slotScripts[slotName] });

                          case 4:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this2);
                  }));

                  return function (_x3) {
                    return _ref4.apply(this, arguments);
                  };
                }());
                return _context4.abrupt('return', Promise.all(appScriptImports));

              case 3:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, _this2);
      }));

      return function (_x2) {
        return _ref3.apply(this, arguments);
      };
    }();

    this._hydrateScript = function (currentAppName) {
      return function () {
        var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(appScript) {
          var slotElement, newApp, script;
          return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
              switch (_context5.prev = _context5.next) {
                case 0:
                  slotElement = _this2._getSlotElement(appScript.slot);
                  newApp = _this2._guestApps[currentAppName];

                  if (slotElement) {
                    _context5.next = 5;
                    break;
                  }

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.hydrate_page.missing_element.' + appScript.slot, id: appScript.name });
                  return _context5.abrupt('return', null);

                case 5:
                  if (!(!appScript.script || typeof appScript.script.hydrate !== 'function')) {
                    _context5.next = 7;
                    break;
                  }

                  return _context5.abrupt('return', null);

                case 7:
                  _context5.prev = 7;
                  script = appScript.script;

                  if (!(script.version === 2)) {
                    _context5.next = 11;
                    break;
                  }

                  return _context5.abrupt('return', script.hydrate(slotElement, newApp));

                case 11:
                  return _context5.abrupt('return', script.hydrate(slotElement, history, newApp));

                case 14:
                  _context5.prev = 14;
                  _context5.t0 = _context5['catch'](7);

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.hydrate_page.run_script', id: appScript.name });
                  return _context5.abrupt('return', null);

                case 18:
                case 'end':
                  return _context5.stop();
              }
            }
          }, _callee5, _this2, [[7, 14]]);
        }));

        return function (_x4) {
          return _ref5.apply(this, arguments);
        };
      }();
    };

    this._unmountScript = function (appName) {
      return function () {
        var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(appScript) {
          var slotElement, newApp, script;
          return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
              switch (_context6.prev = _context6.next) {
                case 0:
                  slotElement = _this2._getSlotElement(appScript.slot);
                  newApp = _this2._guestApps[appName];

                  if (!(!slotElement || !appScript.script || typeof appScript.script.unmount !== 'function')) {
                    _context6.next = 5;
                    break;
                  }

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.unmount.missing', id: appScript.name });
                  return _context6.abrupt('return', null);

                case 5:
                  _context6.prev = 5;
                  script = appScript.script;

                  if (!(script.version === 2)) {
                    _context6.next = 9;
                    break;
                  }

                  return _context6.abrupt('return', script.unmount(slotElement, newApp));

                case 9:
                  return _context6.abrupt('return', script.unmount(slotElement, history, newApp));

                case 12:
                  _context6.prev = 12;
                  _context6.t0 = _context6['catch'](5);

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.unmount.error', id: appScript.name });
                  return _context6.abrupt('return', null);

                case 16:
                case 'end':
                  return _context6.stop();
              }
            }
          }, _callee6, _this2, [[5, 12]]);
        }));

        return function (_x5) {
          return _ref6.apply(this, arguments);
        };
      }();
    };

    this._mountScript = function (appName) {
      return function () {
        var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(appScript) {
          var slotElement, newApp, script;
          return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
              switch (_context7.prev = _context7.next) {
                case 0:
                  slotElement = _this2._getSlotElement(appScript.slot);
                  newApp = _this2._guestApps[appName];

                  if (!(!slotElement || !newApp || !appScript.script || typeof appScript.script.mount !== 'function')) {
                    _context7.next = 5;
                    break;
                  }

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.mount.missing', id: appScript.name });
                  return _context7.abrupt('return', null);

                case 5:
                  _context7.prev = 5;
                  script = appScript.script;

                  if (!(script.version === 2)) {
                    _context7.next = 9;
                    break;
                  }

                  return _context7.abrupt('return', script.mount(slotElement, newApp));

                case 9:
                  return _context7.abrupt('return', script.mount(slotElement, history, newApp));

                case 12:
                  _context7.prev = 12;
                  _context7.t0 = _context7['catch'](5);

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.mount.error', id: appScript.name });
                  return _context7.abrupt('return', null);

                case 16:
                case 'end':
                  return _context7.stop();
              }
            }
          }, _callee7, _this2, [[5, 12]]);
        }));

        return function (_x6) {
          return _ref7.apply(this, arguments);
        };
      }();
    };

    this._stateChangeScript = function (appName) {
      return function () {
        var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(appScript) {
          var updateApp, script;
          return regeneratorRuntime.wrap(function _callee8$(_context8) {
            while (1) {
              switch (_context8.prev = _context8.next) {
                case 0:
                  updateApp = _this2._guestApps[appName];

                  if (!(!updateApp || !appScript.script || typeof appScript.script.onStateChange !== 'function')) {
                    _context8.next = 4;
                    break;
                  }

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.state_change.missing', id: appScript.name });
                  return _context8.abrupt('return', null);

                case 4:
                  _context8.prev = 4;
                  script = appScript.script;

                  if (!(script.version === 2)) {
                    _context8.next = 8;
                    break;
                  }

                  return _context8.abrupt('return', script.onStateChange(updateApp));

                case 8:
                  return _context8.abrupt('return', script.onStateChange(history, updateApp));

                case 11:
                  _context8.prev = 11;
                  _context8.t0 = _context8['catch'](4);

                  _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.state_change.error', id: appScript.name });
                  return _context8.abrupt('return', null);

                case 15:
                case 'end':
                  return _context8.stop();
              }
            }
          }, _callee8, _this2, [[4, 11]]);
        }));

        return function (_x7) {
          return _ref8.apply(this, arguments);
        };
      }();
    };

    this._hydratePage = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee9() {
      var currentAppName, pageScripts, hydratePromises;
      return regeneratorRuntime.wrap(function _callee9$(_context9) {
        while (1) {
          switch (_context9.prev = _context9.next) {
            case 0:
              currentAppName = _this2._currentAppName;

              if (currentAppName) {
                _context9.next = 4;
                break;
              }

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.hydrate_page.missing_route' });
              return _context9.abrupt('return', null);

            case 4:
              _context9.prev = 4;
              _context9.next = 7;
              return _this2._getPageScripts(currentAppName);

            case 7:
              pageScripts = _context9.sent;
              hydratePromises = pageScripts.map(_this2._hydrateScript(currentAppName));
              return _context9.abrupt('return', Promise.all(hydratePromises));

            case 12:
              _context9.prev = 12;
              _context9.t0 = _context9['catch'](4);

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.hydrate_page.get_scrips', id: currentAppName });
              return _context9.abrupt('return', null);

            case 16:
            case 'end':
              return _context9.stop();
          }
        }
      }, _callee9, _this2, [[4, 12]]);
    }));

    this._updatePage = function () {
      var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee10(newAppName) {
        var oldAppName, _ref11, oldAppScripts, newAppScripts, oldAppScriptNames, newAppScriptNames, unmountPromises, mountPromises, updatePromises;

        return regeneratorRuntime.wrap(function _callee10$(_context10) {
          while (1) {
            switch (_context10.prev = _context10.next) {
              case 0:
                oldAppName = _this2._currentAppName;
                _context10.next = 3;
                return Promise.all([_this2._getPageScripts(oldAppName), _this2._getPageScripts(newAppName)]);

              case 3:
                _ref11 = _context10.sent;
                oldAppScripts = _ref11[0];
                newAppScripts = _ref11[1];
                oldAppScriptNames = oldAppScripts.map(function (_ref12) {
                  var name = _ref12.name;
                  return name;
                });
                newAppScriptNames = newAppScripts.map(function (_ref13) {
                  var name = _ref13.name;
                  return name;
                });
                unmountPromises = oldAppScripts.filter(function (appScript) {
                  return !newAppScriptNames.includes(appScript.name);
                }).map(_this2._unmountScript(oldAppName));
                mountPromises = newAppScripts.filter(function (appScript) {
                  return !oldAppScriptNames.includes(appScript.name);
                }).map(_this2._mountScript(newAppName));
                updatePromises = oldAppScripts.filter(function (appScript) {
                  return newAppScriptNames.includes(appScript.name);
                }).map(_this2._stateChangeScript(newAppName));
                _context10.next = 13;
                return Promise.all(unmountPromises);

              case 13:
                _context10.next = 15;
                return Promise.all(mountPromises);

              case 15:
                _context10.next = 17;
                return Promise.all(updatePromises);

              case 17:
                return _context10.abrupt('return', null);

              case 18:
              case 'end':
                return _context10.stop();
            }
          }
        }, _callee10, _this2);
      }));

      return function (_x8) {
        return _ref10.apply(this, arguments);
      };
    }();

    this._onStateChange = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee11() {
      var newAppName;
      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              newAppName = _this2._getAppFromPath();

              if (newAppName) {
                _context11.next = 4;
                break;
              }

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.update_app.app_not_found' });
              return _context11.abrupt('return', null);

            case 4:
              _context11.prev = 4;
              _context11.next = 7;
              return _this2._updatePage(newAppName);

            case 7:
              _context11.next = 13;
              break;

            case 9:
              _context11.prev = 9;
              _context11.t0 = _context11['catch'](4);

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.update_app', id: newAppName });
              return _context11.abrupt('return', null);

            case 13:

              _this2._currentAppName = newAppName;

              return _context11.abrupt('return', null);

            case 15:
            case 'end':
              return _context11.stop();
          }
        }
      }, _callee11, _this2, [[4, 9]]);
    }));
    this.init = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee12() {
      var browserTitle, browserPath, browserQuery, currentAppName;
      return regeneratorRuntime.wrap(function _callee12$(_context12) {
        while (1) {
          switch (_context12.prev = _context12.next) {
            case 0:
              if (Object.keys(_this2._appSlots).every(function (slotName) {
                return _this2._getSlotElement(slotName);
              })) {
                _context12.next = 3;
                break;
              }

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.init.missing_elements' });
              return _context12.abrupt('return', null);

            case 3:
              if (!(!w || !w.document)) {
                _context12.next = 6;
                break;
              }

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.init.no_window' });
              return _context12.abrupt('return', null);

            case 6:
              browserTitle = w.document.title;
              browserPath = w.document.location.pathname;
              browserQuery = w.document.location.search;


              history.replaceState({}, browserTitle, '' + browserPath + browserQuery);

              currentAppName = _this2._getAppFromPath();

              if (currentAppName) {
                _context12.next = 14;
                break;
              }

              _this2._analytics.error({ eventTitle: _this2._analytics.namespace + '.init_app.no_route' });
              return _context12.abrupt('return', null);

            case 14:

              _this2._currentAppName = currentAppName;

              _context12.next = 17;
              return _this2._hydratePage();

            case 17:

              history.Adapter.bind(w, 'statechange', _this2._onStateChange);

              return _context12.abrupt('return', null);

            case 19:
            case 'end':
              return _context12.stop();
          }
        }
      }, _callee12, _this2);
    }));
  }, _temp;
}